| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
ADC Peripheral Driver (AVR8)
ADC Driver - LUFA/Drivers/Peripheral/ADC.h

## Functions
static void | ADC_Disable (void) ATTR_ALWAYS_INLINE
static void | ADC_DisableChannel (const uint8_t ChannelIndex)
static uint16_t | ADC_GetChannelReading (const uint16_t MUXMask) ATTR_WARN_UNUSED_RESULT
static uint16_t | ADC_GetResult (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
static bool | ADC_GetStatus (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
static void | ADC_Init (const uint8_t Mode) ATTR_ALWAYS_INLINE
static bool | ADC_IsReadingComplete (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
static void | ADC_SetupChannel (const uint8_t ChannelIndex)
static void | ADC_StartReading (const uint16_t MUXMask)

## ADC Reference Configuration Masks
#define | ADC_REFERENCE_AREF 0
#define | ADC_REFERENCE_AVCC (1 << REFS0)
#define | ADC_REFERENCE_INT2560MV ((1 << REFS1) | (1 << REFS0))

## ADC Result Adjustment Configuration Masks
#define | ADC_LEFT_ADJUSTED (1 << ADLAR)
#define | ADC_RIGHT_ADJUSTED (0 << ADLAR)

## ADC Mode Configuration Masks
#define | ADC_FREE_RUNNING (1 << ADATE)
#define | ADC_SINGLE_CONVERSION (0 << ADATE)

## ADC Prescaler Configuration Masks
#define | ADC_PRESCALE_2 (1 << ADPS0)
#define | ADC_PRESCALE_4 (1 << ADPS1)
#define | ADC_PRESCALE_8 ((1 << ADPS0) | (1 << ADPS1))
#define | ADC_PRESCALE_16 (1 << ADPS2)
#define | ADC_PRESCALE_32 ((1 << ADPS2) | (1 << ADPS0))
#define | ADC_PRESCALE_64 ((1 << ADPS2) | (1 << ADPS1))
#define | ADC_PRESCALE_128 ((1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0))

## ADC MUX Masks
#define | ADC_CHANNEL0 (0x00 << MUX0)
#define | ADC_CHANNEL1 (0x01 << MUX0)
#define | ADC_CHANNEL2 (0x02 << MUX0)
#define | ADC_CHANNEL3 (0x03 << MUX0)
#define | ADC_CHANNEL4 (0x04 << MUX0)
#define | ADC_CHANNEL5 (0x05 << MUX0)
#define | ADC_CHANNEL6 (0x06 << MUX0)
#define | ADC_CHANNEL7 (0x07 << MUX0)
#define | ADC_CHANNEL8 ((1 << 8) | (0x00 << MUX0))
#define | ADC_CHANNEL9 ((1 << 8) | (0x01 << MUX0))
#define | ADC_CHANNEL10 ((1 << 8) | (0x02 << MUX0))
#define | ADC_CHANNEL11 ((1 << 8) | (0x03 << MUX0))
#define | ADC_CHANNEL12 ((1 << 8) | (0x04 << MUX0))
#define | ADC_CHANNEL13 ((1 << 8) | (0x05 << MUX0))
#define | ADC_INT_TEMP_SENS ((1 << 8) | (0x07 << MUX0))
#define | ADC_1100MV_BANDGAP (0x1E << MUX0)
#define | ADC_GET_CHANNEL_MASK(Channel) CONCAT_EXPANDED(ADC_CHANNEL, Channel)

## Detailed Description

# Module Description

On-chip Analogue-to-Digital converter (ADC) driver for supported U4, U6 and U7 model AVRs that contain an ADC peripheral internally.

Note
  This file should not be included directly. It is automatically included as needed by the ADC driver dispatch header located in LUFA/Drivers/Peripheral/ADC.h.

# Example Usage

The following snippet is an example of how this module may be used within a typical application.

// Initialize the ADC driver before first use
ADC_Init(ADC_FREE_RUNNING | ADC_PRESCALE_32);
// Must setup the ADC channel to read beforehand
ADC_SetupChannel(1);
// Perform a single conversion of the ADC channel 1
ADC_GetChannelReading(ADC_REFERENCE_AVCC | ADC_RIGHT_ADJUSTED | ADC_CHANNEL1);
printf("Conversion Result: %d\r\n", ADC_GetResult());
// Start reading ADC channel 1 in free running (continuous conversion) mode
ADC_StartReading(ADC_REFERENCE_AVCC | ADC_RIGHT_ADJUSTED | ADC_CHANNEL1);
for (;;)
{
while (!(ADC_IsReadingComplete())) {};
printf("Conversion Result: %d\r\n", ADC_GetResult());
}

## Macro Definition Documentation

#define ADC_1100MV_BANDGAP (0x1E << MUX0)

MUX mask define for the internal 1.1V band-gap channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

#define ADC_CHANNEL0 (0x00 << MUX0)

MUX mask define for the ADC0 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

#define ADC_CHANNEL1 (0x01 << MUX0)

MUX mask define for the ADC1 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

#define ADC_CHANNEL10 ((1 << 8) | (0x02 << MUX0))

MUX mask define for the ADC10 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

Note
  Not available on all AVR models.

#define ADC_CHANNEL11 ((1 << 8) | (0x03 << MUX0))

MUX mask define for the ADC11 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

Note
  Not available on all AVR models.

#define ADC_CHANNEL12 ((1 << 8) | (0x04 << MUX0))

MUX mask define for the ADC12 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

Note
  Not available on all AVR models.

#define ADC_CHANNEL13 ((1 << 8) | (0x05 << MUX0))

MUX mask define for the ADC13 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

Note
  Not available on all AVR models.

#define ADC_CHANNEL2 (0x02 << MUX0)

MUX mask define for the ADC2 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

Note
  Not available on all AVR models.

#define ADC_CHANNEL3 (0x03 << MUX0)

MUX mask define for the ADC3 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

Note
  Not available on all AVR models.

#define ADC_CHANNEL4 (0x04 << MUX0)

MUX mask define for the ADC4 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

#define ADC_CHANNEL5 (0x05 << MUX0)

MUX mask define for the ADC5 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

#define ADC_CHANNEL6 (0x06 << MUX0)

MUX mask define for the ADC6 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

#define ADC_CHANNEL7 (0x07 << MUX0)

MUX mask define for the ADC7 channel of the ADC. See ADC_StartReading and ADC_GetChannelReading.

#define ADC_CHANNEL8 ((1 << 8) | (0x00 << MUX0))

MUX mask define for the ADC8 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

Note
  Not available on all AVR models.

#define ADC_CHANNEL9 ((1 << 8) | (0x01 << MUX0))

MUX mask define for the ADC9 channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

Note
  Not available on all AVR models.

#define ADC_FREE_RUNNING (1 << ADATE)

Sets the ADC mode to free running, so that conversions take place continuously as fast as the ADC is capable of at the given input clock speed.

#define ADC_GET_CHANNEL_MASK | ( |  | Channel | ) | CONCAT_EXPANDED(ADC_CHANNEL, Channel)

Retrieves the ADC MUX mask for the given ADC channel number.

Attention
  This macro will only work correctly on channel numbers that are compile-time constants defined by the preprocessor.

Parameters

  [in] | Channel | Index of the ADC channel whose MUX mask is to be retrieved.

#define ADC_INT_TEMP_SENS ((1 << 8) | (0x07 << MUX0))

MUX mask define for the internal temperature sensor channel of the ADC. See ADC_StartReading() and ADC_GetChannelReading().

Note
  Not available on all AVR models.

#define ADC_LEFT_ADJUSTED (1 << ADLAR)

Left-adjusts the 10-bit ADC result, so that the upper 8 bits of the value returned by the ADC_GetResult() macro contain the 8 most significant bits of the result.

#define ADC_PRESCALE_128 ((1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0))

Sets the ADC input clock to prescale by a factor of 128 the AVR's system clock.

#define ADC_PRESCALE_16 (1 << ADPS2)

Sets the ADC input clock to prescale by a factor of 16 the AVR's system clock.

#define ADC_PRESCALE_2 (1 << ADPS0)

Sets the ADC input clock to prescale by a factor of 2 the AVR's system clock.

#define ADC_PRESCALE_32 ((1 << ADPS2) | (1 << ADPS0))

Sets the ADC input clock to prescale by a factor of 32 the AVR's system clock.

#define ADC_PRESCALE_4 (1 << ADPS1)

Sets the ADC input clock to prescale by a factor of 4 the AVR's system clock.

#define ADC_PRESCALE_64 ((1 << ADPS2) | (1 << ADPS1))

Sets the ADC input clock to prescale by a factor of 64 the AVR's system clock.

#define ADC_PRESCALE_8 ((1 << ADPS0) | (1 << ADPS1))

Sets the ADC input clock to prescale by a factor of 8 the AVR's system clock.

#define ADC_REFERENCE_AREF 0

Reference mask, for using the voltage present at the AVR's AREF pin for the ADC reference.

#define ADC_REFERENCE_AVCC (1 << REFS0)

Reference mask, for using the voltage present at the AVR's AVCC pin for the ADC reference.

#define ADC_REFERENCE_INT2560MV ((1 << REFS1) | (1 << REFS0))

Reference mask, for using the internally generated 2.56V reference voltage as the ADC reference.

#define ADC_RIGHT_ADJUSTED (0 << ADLAR)

Right-adjusts the 10-bit ADC result, so that the lower 8 bits of the value returned by the ADC_GetResult() macro contain the 8 least significant bits of the result.

#define ADC_SINGLE_CONVERSION (0 << ADATE)

Sets the ADC mode to single conversion, so that only a single conversion will take place before the ADC returns to idle.

## Function Documentation

static void ADC_Disable | ( | void |  | ) |
| inline static

Turns off the ADC. If this is called, any further ADC operations will require a call to ADC_Init() before the ADC can be used again.

static void ADC_DisableChannel | ( | const uint8_t | ChannelIndex | ) |
| inline static

De-configures the given ADC channel, re-enabling digital I/O mode instead of analog. This function sets the associated port pin as an input and re-enabled the digital portion of the I/O.

Note
  This must only be called for ADC channels with are connected to a physical port pin of the AVR, denoted by its special alternative function ADCx.

Warning
  The channel number must be specified as an integer, and not a `ADC_CHANNEL*` mask.

Parameters

  [in] | ChannelIndex | ADC channel number to set up for conversions.

static uint16_t ADC_GetChannelReading | ( | const uint16_t | MUXMask | ) |
| inline static

Performs a complete single reading from channel, including a polling spin-loop to wait for the conversion to complete, and the returning of the converted value.

Note
  For free running mode, the automated conversions should be initialized with a single call to ADC_StartReading() to select the channel and begin the automated conversions, and the results read directly from the ADC_GetResult() instead to reduce overhead.

Parameters

  [in] | MUXMask | Mask comprising of an ADC channel mask, reference mask and adjustment mask.

Returns
  Converted ADC result for the given ADC channel.

static uint16_t ADC_GetResult | ( | void |  | ) |
| inline static

Retrieves the conversion value of the last completed ADC conversion and clears the reading completion flag.

Returns
  The result of the last ADC conversion as an unsigned value.

static bool ADC_GetStatus | ( | void |  | ) |
| inline static

Indicates if the ADC is currently enabled.

Returns
  Boolean `true` if the ADC subsystem is currently enabled, `false` otherwise.

static void ADC_Init | ( | const uint8_t | Mode | ) |
| inline static

Initializes the ADC, ready for conversions. This must be called before any other ADC operations. The "mode" parameter should be a mask comprised of a conversion mode (free running or single) and prescaler masks.

Parameters

  [in] | Mode | Mask of ADC prescale and mode settings.

static bool ADC_IsReadingComplete | ( | void |  | ) |
| inline static

Indicates if the current ADC conversion is completed, or still in progress.

Returns
  Boolean `false` if the reading is still taking place, or true if the conversion is complete and ready to be read out with ADC_GetResult().

static void ADC_SetupChannel | ( | const uint8_t | ChannelIndex | ) |
| inline static

Configures the given ADC channel, ready for ADC conversions. This function sets the associated port pin as an input and disables the digital portion of the I/O to reduce power consumption.

Note
  This must only be called for ADC channels with are connected to a physical port pin of the AVR, denoted by its special alternative function ADCx.

Warning
  The channel number must be specified as an integer, and not a `ADC_CHANNEL*` mask.

Parameters

  [in] | ChannelIndex | ADC channel number to set up for conversions.

static void ADC_StartReading | ( | const uint16_t | MUXMask | ) |
| inline static

Starts the reading of the given channel, but does not wait until the conversion has completed. Once executed, the conversion status can be determined via the ADC_IsReadingComplete() macro and the result read via the ADC_GetResult() macro.

If the ADC has been initialized in free running mode, calling this function once will begin the repeated conversions. If the ADC is in single conversion mode (or the channel to convert from is to be changed), this function must be called each time a conversion is to take place.

Parameters

  [in] | MUXMask | ADC channel mask, reference mask and adjustment mask.